//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBSpriteTextureButton extends MSBPropertyButton;

var string ViewAppendix[4];
var int AniNumber;
var name StateName;                                    // either 'Idle', 'Move' or 'Anim'
var bool bLoad;

var string Material;
var Material Tex;
var MSBSpritePawn sP;


var class<MSBPropertyButton> ButtonClass;
var array <MSBPropertyButton> ListButton;

//spawning the MSBPropertyButton for the Material Text
function initPropButton()
{
ButtonClass = class<MSBPropertyButton>(DynamicLoadObject("MSBPropertyButtons.MSBPropertyButtonText", class'Class'));
ListButton[0]=Spawn(ButtonClass);
ListButton[0].Parent=self;
ListButton[0].SubLevel++;
ListButton[0].xPos=xpos+width;        //horizontal alignment
ListButton[0].yPos=ypos+height-ListButton[0].yPos;        //horizontal alignment
ListButton[0].BtnName="Material";
ListButton[0].Property="Material";

//set up ViewAppendices according to State we're in
if (StateName=='Idle')
  {
  ViewAppendix[0]="IdleL_A00";
  ViewAppendix[1]="IdleR_A00";
  ViewAppendix[2]="IdleB_A00";
  ViewAppendix[3]="IdleF_A00";
  }

if (StateName=='Move')
  {
  ViewAppendix[0]="MoveL_A00";
  ViewAppendix[1]="MoveR_A00";
  ViewAppendix[2]="MoveB_A00";
  ViewAppendix[3]="MoveF_A00";
  }

if (StateName=='Anim')
  {
  ViewAppendix[0]="AnimL_A00";
  ViewAppendix[1]="AnimR_A00";
  ViewAppendix[2]="AnimB_A00";
  ViewAppendix[3]="AnimF_A00";
  CreateAnimNavi();
  }
}

function CreateAnimNavi()
{
ButtonClass = class<MSBPropertyButton>(DynamicLoadObject("MSBPropertyButtons.MSBPropertyButtonAssign", class'Class'));
ListButton[1]=Spawn(ButtonClass);
ListButton[1].Parent=self;
ListButton[1].SubLevel++;
ListButton[1].xPos=xpos+width;        //horizontal alignment
ListButton[1].yPos=ListButton[0].ypos+ListButton[0].height;        //horizontal alignment
ListButton[1].BtnName="Next";
ListButton[1].Property="Dummy";

ListButton[2]=Spawn(ButtonClass);
ListButton[2].Parent=self;
ListButton[2].SubLevel++;
ListButton[2].xPos=xpos+width;        //horizontal alignment
ListButton[2].yPos=ListButton[1].ypos+ListButton[1].height;        //horizontal alignment
ListButton[2].BtnName="Prev";
ListButton[2].Property="Dummy";
}

function Trigger(Actor Other, Pawn EventInstigator)
{
local string MatName;
local int i;

if (Other==ListButton[1])
  {
  if (AniNumber<MSB2DCharEdController(M).Animations.Length-1)
    Material=MSB2DCharEdController(M).Animations[++AniNumber];
  }
if (Other==ListButton[2])
  {
  if (AniNumber>0)
    Material=MSB2DCharEdController(M).Animations[--AniNumber];
  }


if (Other==ListButton[0] && stateName=='Anim')
  MSB2DCharEdController(M).Animations[MSB2DCharEdController(M).Animations.length]=Material;

for (i=0;i<4;i++)
 {
 MatName=Material$ViewAppendix[i];
 Tex=Material(DynamicLoadObject(MatName,class'Material',true));
 if (stateName=='Anim')
   sP.ScriptAni[i]=Tex;
 if (stateName=='Idle')
   sP.IdleAni[i]=Tex;
 if (stateName=='Move')
   sP.MoveAni[i]=Tex;
 }

if (sP!=None)
  {
  if (StateName=='Idle')
    sP.GotoState(stateName);
  if (StateName=='Move')
    sP.GotoState('SpriteMoving');
  if (StateName=='Anim')
    sP.GotoState('Animating');
  }

}

function initButton(Canvas C)
{
super.InitButton(C);
C.DrawText(BtnName,true);
//draw Texture Preview ontop of Material
C.SetPos(xpos+10,ypos+10);

if (sP!=None && Tex!=None)
  C.DrawTile(Tex,128 * Tex.MaterialUSize()/Tex.MaterialVSize(),128,0,0,Tex.MaterialUSize(),Tex.MaterialVSize());
C.SetPos(xpos,ypos);
}

function LeftBtn(Canvas C)
{
super.LeftBtn(C);
initPropButton();
LeftBtnFinished(C);
}

defaultproperties
{
width=128
height=142
xpos=200
ypos=200
BtnName="Front";
StateName=Idle
}
