//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBSetPoseNode extends MSBScriptNode;

var string PoseName;
var Actor PoseActor;
var float BlendTime;
var bool addPose;
var int maxBones;

function fillSequence()
{
 local MSBAction_SetPose asp;
 local Action_WaitForTimer wft;

 local int i;
 local MSBAniKey A;

 super.fillSequence();
 //create new setPose Action and set our Properties

 if (PoseActor.IsA('MSBFullRig'))
   maxBones=63;
 else
   maxBones=26;

 asp=new(None) class'MSBAction_SetPose';
 asp.KeyActor=PoseActor;
 asp.blendTime=BlendTime;
 asp.addPose=addPose;
 for (i=0;i<maxBones;i++)
  {
  A=Level.Game.LoadDataObject(class'MSBAniKey',PoseName$"Key"$i,"MovieSandboxPoses");
  asp.PoseKey[i]=new class'MSBAniKey';
  asp.PoseKey[i].BoneNumber=i;
  asp.PoseKey[i].BoneRotation=A.BoneRotation;
  }
Actions[0]=asp;



if (BlendTime>0)
  {
  wft=new class'Action_WaitForTimer';
  wft.PauseTime=BlendTime;
  Actions[1]=wft;
  }
}

function execute(string Data)
{
 local int i;
 local MSBInterpolationHelper IH;
 local MSBAniKey A;
 local MSBAniKey PoseKey[63];

 if (PoseActor.IsA('MSBFullRig'))
   maxBones=63;
 else
   maxBones=26;

 for (i=0;i<maxBones;i++)
  {
  A=Level.Game.LoadDataObject(class'MSBAniKey',PoseName$"Key"$i,"MovieSandboxPoses");
  PoseKey[i]=new class'MSBAniKey';
  PoseKey[i].BoneNumber=i;
  PoseKey[i].BoneRotation=A.BoneRotation;
  }

 if (BlendTime==0)
   {
   for (i=0;i<maxBones;i++)
     {
     PoseKey[i].KeyActor=PoseActor;
     PoseKey[i].changeBoneRotation();
     }
   }
 else
   {
   for (i=0;i<maxBones;i++)
     {
     PoseKey[i].KeyActor=PoseActor;
     IH=Spawn(class'MSBInterpolationHelper');
     IH.TargetKey=PoseKey[i];
     IH.blendTime=BlendTime;
     IH.initializePoseTween();
     }
   }
}



defaultproperties
{
Description="EventName"
}

