//-----------------------------------------------------------
//  Copyright 2006 Friedrich Kirschner
//-----------------------------------------------------------

class MSBNodeButton extends MSBListButton;

#exec texture Import File=Textures\Node.tga Name=Node_Icon Mips=Off Alpha=1

var MSBNodeInButton NodeIn;
var MSBNodeOutButton NodeOut;

var MSBScriptNode Order;

var bool bDragged;
var bool rHasClickedAgain;
var bool bDisplayed;

var string special;

var float xDist,yDist;

var array<string> Properties;

var array<Material> oldActorMaterial;
var array<Actor> FocusActor;

event PostBeginPlay()
{
M=MSBController(Level.getLocalPlayerController());
M.LevelNodes[M.LevelNodes.Length]=self;

NodeIn=Spawn(class'MSBNodeInButton');
NodeIn.myNode=self;
NodeOut=Spawn(class'MSBNodeOutButton',self,,M.Location);
NodeOut.myNode=self;
NodeOut.col=col;
super.PostBeginPlay();
}

function MouseOver(Canvas C)
{
local int i,j;
local string ObjectName, MapName;

super.MouseOver(C);
for (i=0;i<ButtonList.length;i++)
 {
  if (Caps(ButtonList[i])=="MSBPropertyButtonS.MSBPropertyButton3D")
    {
    ObjectName=Order.GetPropertyText(Properties[i]);
    ObjectName=GetItemName(ObjectName);
    ObjectName-="'";
    MapName=Left(string(Level), InStr(string(Level), "."));
    ObjectName=MapName$"."$ObjectName;
    FocusActor[j]=Actor(FindObject(ObjectName,class'Actor'));
    if (FocusActor[j]!=None)
      {
      oldActorMaterial[j]=FocusActor[j].Skins[0];
      FocusActor[j].Skins[0]=Mat;
      j++;
      }
    }
  }
}

function initButton(Canvas C)
{
local int f;

if (bDragged)
  {
  xPos=Mouse.xPos+xDist;
  yPos=Mouse.yPos+yDist;
  }

super.initButton(C);

C.SetPos(xPos,yPos);
C.FontScaleX=buttonFontScale;
C.FontScaleY=buttonFontScale;
C.DrawText(BtnName);
C.FontScaleX=fontScale;
C.FontScaleY=fontScale;

if (bEnabled)
 {
 if (rHasClicked && Mouse.btnTwo)
   {
   rHasClickedAgain=true;
   RightBtnFinished(C);
   rHasClickedAgain=false;
   }
 }

//defocus
for (f=0;f<FocusActor.length;f++)
  if (FocusActor[f]!=None && FocusActor[f].Skins[0]==Mat)
    FocusActor[f].Skins[0]=oldActorMaterial[f];
}

function LeftBtn(Canvas C)
{
local int i;

super.LeftBtn(C);
for (i=0;i<Buttonlist.Length; i++)
  {
   MSBPropertyButton(ListButton[i]).Parent=self;
   MSBPropertyButton(ListButton[i]).Property=Properties[i];
  }
}

function RightBtn(Canvas C)
{
super.RightBtn(C);
bDragged=true;
xDist=xPos-Mouse.xPos;
yDist=yPos-Mouse.yPos;

}

function RightBtnFinished(Canvas C)
{
local int i;

rHasClicked=false;
//enable all other buttons after second press
for (i=0;i<M.myHud.Overlays.Length-1;i++)
  if (M.myHud.Overlays[i].IsA('MSBGuiOverlay'))
    MSBGuiOverlay(M.myHud.Overlays[i]).bEnabled=true;

Mouse.btnTwo=false;
bDragged=false;
}

function hideNode()
{
bDisplayed=true;
M.myHUD.RemoveHudOverlay(NodeOut);
M.myHUD.RemoveHudOverlay(NodeIn);
M.myHUD.RemoveHudOverlay(self);
}

function showNode()
{
local HudOverlay mOverlay;

bDisplayed=false;
mOverlay=M.myHUD.Overlays[M.myHUD.Overlays.Length-1]; // POP Mouse from Overlay Stack
M.myHUD.RemoveHudOverlay(mOverlay);
M.myHUD.AddHudOverlay(self);
if (NodeIn!=None)
  M.myHUD.AddHudOverlay(NodeIn);
M.myHUD.AddHudOverlay(NodeOut);
M.myHUD.AddHudOverlay(mOverlay);            //PUSH Mouse back on top
}

defaultproperties
{
width=64
height=12
Mat=Material'Node_Icon'
BtnName="Node"
ypos=100
xpos=100
ButtonList(0)=None;
}

