//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBVoxelPawn extends MSBPawn;

var vector MasterSize;
var array<MSBMasterBlock> Blocks;
var array<MSBsimpleBlock> MSBFaceBlock;                      //can mimic and talk

event PostBeginPlay()
{
super.PostBeginPlay();
setMSBMasterBlocks();
}

// *******************************************************************************
// Lipsyncing
// *******************************************************************************

function Talk()
{
local int i;

for (i=0;i<MSBFaceBlock.length;i++)
  MSBFaceBlock[i].Talk();
}

function Mimic()
{
local int i;

super.Mimic();
for (i=0;i<MSBFaceBlock.length;i++)
  MSBFaceBlock[i].Mimic(eyeX, eyeY, browX, browY);
}

// *******************************************************************************
// Loading Voxels and cleaning up
// *******************************************************************************

function LoadCharacter()
{
local MSBVoxelCharacterSave char;
local class<MSBVoxelFace> MSBVoxelFaceClass;
local int bone,block, i;
local MSBMasterBlock Master;

char=Level.Game.LoadDataObject(class'MSBVoxelCharacterSave',content,"Char"$content);
for(bone=0;bone<char.Parts.length;bone++)
  {
  Master=Blocks[bone];
  //get rid of old blocks
  Master.clearBlocks();
  //set new blocks
  for (block=0;block<char.Parts[bone].Col.length;block++)
    {
    Master.S[block]=Spawn(class'MSBsimpleBlock',,,Master.Location);
    Master.S[block].Skins[0]=new() class'ColorModifier';
    ColorModifier(Master.S[block].Skins[0]).Color=char.Parts[bone].Col[block];
    ColorModifier(Master.S[block].Skins[0]).Material=ColorModifier(Master.Skins[0]).Material;
//    if (char.Parts[Bone].drawScale.Length>0 && char.Parts[Bone].drawScale[block]>0)
    Master.S[block].SetDrawScale(char.Parts[Bone].drawScale[block]);
    Master.AttachToBone(Master.S[Master.S.length-1],'');
    Master.S[block].setRelativeLocation(char.Parts[bone].BlockRelLocation[block] << Master.Rotation);
    Master.S[block].M=Master;
    }
  //set mouth block
  Log("Character Mouth Master Bone:"@char.mouthMaster);
  if (char.MouthMaster>0 && char.MouthMaster==bone)
    {
    MSBVoxelFaceClass=class<MSBVoxelFace>(DynamicLoadObject(char.MouthClass, class'Class'));
    MSBFaceBlock[i]=Spawn(MSBVoxelFaceClass,,,Master.Location);
    Log("Mouth found!"@MSBFaceBlock[0]);
    Master.AttachToBone(MSBFaceBlock[i],'');
    MSBFaceBlock[i].setRelativeLocation(char.MouthRelLocation << Master.Rotation);
    MSBFaceBlock[i].M=Master;
    i++;
    }
  Master.SetDrawType(DT_None);
  }
if (MSBFaceBlock.Length>0)
  bTalkable=true;
}

function setMSBMasterBlocks()
{
local coords C[26];
local int i;

C[0]=GetBoneCoords('Bip01');

C[1]=GetBoneCoords('Bip01 Pelvis');
C[2]=GetBoneCoords('bip01 Spine');
C[3]=GetBoneCoords('bip01 Spine1');
C[4]=GetBoneCoords('bip01 Spine2');
C[5]=GetBoneCoords('Bip01 Neck');

C[6]=GetBoneCoords('Bip01 R Clavicle');
C[7]=GetBoneCoords('Bip01 R UpperArm');
C[8]=GetBoneCoords('Bip01 R Forearm');
C[9]=GetBoneCoords('Bip01 R Hand');
C[10]=GetBoneCoords('Bip01 R Finger');
C[11]=GetBoneCoords('Bone_weapon');

C[12]=GetBoneCoords('Bip01 L Clavicle');
C[13]=GetBoneCoords('Bip01 L UpperArm');
C[14]=GetBoneCoords('Bip01 L Forearm');
C[15]=GetBoneCoords('Bip01 L Hand');
C[16]=GetBoneCoords('Bip01 L Finger');

C[17]=GetBoneCoords('bip01 R Thigh');
C[18]=GetBoneCoords('Bip01 R Calf');
C[19]=GetBoneCoords('Bip01 R Foot');
C[20]=GetBoneCoords('Bip01 R Toe0');

C[21]=GetBoneCoords('bip01 L Thigh');
C[22]=GetBoneCoords('Bip01 L Calf');
C[23]=GetBoneCoords('Bip01 L Foot');
C[24]=GetBoneCoords('Bip01 L Toe0');

C[25]=GetBoneCoords('Bip01 Head');

for (i=0;i<26;i++)
  {
  Blocks[i]=Spawn(class'MSBMasterBlock',self,,C[i].Origin);
  Blocks[i].BoneNumber=i;
  Blocks[i].P=self;
  }
}

function clearPawn()
{
local int i;

for (i=0;i<26;i++)
  {
  Blocks[i].clearBlocks();
  Blocks[i].Destroy();
  if (MSBFaceBlock.length>0)
    MSBFaceBlock[0].Destroy();
  }
}

DefaultProperties
{
bSkinSwap=false
bTalkable=false

bCollideActors=true

Skins(0)=Material'MovieSandboxTextures.Transparent'
Skins(1)=Material'MovieSandboxTextures.Transparent'
Skins(2)=Material'MovieSandboxTextures.Transparent'
Skins(3)=Material'MovieSandboxTextures.Transparent'
}
