//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBVoxelEdFullLoadButton extends MSBListButton;

#exec texture Import File=Textures\loadPawn.tga Name=loadPawn_Icon Mips=Off Alpha=1

var MSBVoxelEdController CC;
var string loadName;

event PostBeginPlay()
{
local int i;
super.PostBeginPlay();
CC=MSBVoxelEdController(M);
for (i=0;i<M.saveCharacters.length;i++)
  ButtonList[i]="MSBPropertyButtons.MSBPropertyButtonAssign";
}

function LeftBtn(Canvas C)                      //spawns subButtons
{
local int i;
super.LeftBtn(C);

for (i=currentpage*0;i<maxButtons; i++)
  {
    MSBPropertyButton(ListButton[i]).Property="LoadName";
    MSBPropertyButton(ListButton[i]).BtnName=M.SaveCharacters[i];
    MSBPropertyButton(ListButton[i]).Parent=self;
  }
}

event Trigger(Actor Other, Pawn EventInstigator)
{
local MSBVoxelCharacterSave char;
local int bone,block;
local MSBMasterBlock Master;
local MSBMouthBlock MSBMouthBlock;

char=Level.Game.LoadDataObject(class'MSBVoxelCharacterSave',loadName,"Char"$loadName);
for(bone=0;bone<char.Parts.length;bone++)
  {
  Master=CC.myReferencePawn.Blocks[bone];
  //get rid of old blocks
  Master.clearBlocks();
  //get rid of MSBMouthBlock
  if (CC.bMouthSpawned)
    {
    CC.FQ.Destroy();
    CC.bMouthSpawned=false;
    }
  //load voxels
  for (block=0;block<char.Parts[bone].Col.length;block++)
    {
    Master.S[block]=Spawn(class'MSBsimpleBlock',,,Master.Location);
    Master.S[block].bEdit=true;
    if (char.Parts[Bone].drawScale.Length>0 && char.Parts[Bone].drawScale[block]>0)
      Master.S[block].SetDrawScale(char.Parts[bone].drawScale[block]);
    Master.S[block].Skins[0]=new() class'ColorModifier';
    ColorModifier(Master.S[block].Skins[0]).Color=char.Parts[bone].Col[block];
    ColorModifier(Master.S[block].Skins[0]).Material=ColorModifier(Master.Skins[0]).Material;
    Master.AttachToBone(Master.S[Master.S.length-1],'');
    Master.S[block].setRelativeLocation(char.Parts[bone].BlockRelLocation[block]);
    Master.S[block].M=Master;
    }
  //load Mouth
  if (char.MouthMaster>0 && char.MouthMaster==bone)
    {
    MSBMouthBlock=Spawn(class'MSBMouthBlock',,,Master.Location);
 //   MSBMouthBlock.Skins[0]=new() class'ColorModifier';
//    ColorModifier(MSBMouthBlock.Skins[0]).Color=char.Parts[bone].Col[block];
//    ColorModifier(Master.S[block].Skins[0]).Material=ColorModifier(Master.Skins[0]).Material;
   MSBMouthBlock.SetDrawScale(char.MouthScale);
    if (char.MouthMesh!="")
      MSBMouthBlock.SetStaticMesh(StaticMesh(DynamicLoadObject(char.MouthMesh,class'StaticMesh')));
    Master.AttachToBone(MSBMouthBlock,'');
    MSBMouthBlock.setRelativeLocation(char.MouthRelLocation << Master.Rotation);
    MSBMouthBlock.M=Master;
    CC.FQ=MSBMouthBlock;
    CC.bMouthSpawned=true;
    }
  }
}


DefaultProperties
{
tooltip="Load a CharacterPart"
Mat=loadPawn_Icon
}
