//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBVoxelEdHud extends MSBHud;

var MSBVoxelEdController CC;
var vector chgLocAbs;
var float dTime;

function PostBeginPlay()
{
super.PostBeginPlay();
CC=MSBVoxelEdController(M);
}

function Tick(float DeltaTime)
{
super.Tick(DeltaTime);
dTime=DeltaTime;
}

function PostRender(Canvas C)
{
local vector chgLoc;
local int i;

super.PostRender(C);

//Draw the MainMenu
if (DrawOverlays)
  {
  for (i = 0; i < Overlays.length; i++)
    Overlays[i].Render(C);
  }

//Move the MSBBlockBrush around
else
  {
  if (CC.DrawBrush!=None)
    {
    if (MouseOverlay.bShiftDown)
      chgLoc.Z=-(MouseOverlay.yPos-CC.oldY);
    else
      chgLoc=CC.yAxis*(MouseOverlay.xPos-CC.oldX)-CC.xAxis*(MouseOverlay.yPos-CC.oldY);

    if (CC.bGrid)
      {
      chgLoc*=dTime*CC.Gridspacing/2*10;
      if (chgLocAbs.X>CC.GridSpacing || chgLocAbs.Y>CC.GridSpacing || chgLocAbs.Z>CC.GridSpacing || chgLocAbs.X<-CC.GridSpacing || chgLocAbs.Y<-CC.GridSpacing ||chgLocAbs.Z<-CC.GridSpacing)
        {
        CC.calculateGrid(chgLocAbs);
        CC.DrawBrush.SetLocation(CC.DrawBrush.Location+chgLocAbs);
        chgLocAbs=chgLocAbs*0;
        }
      else
        chgLocAbs+=chgLoc;
      }
    else
      {
      chgLoc=chgLoc*dTime*80;
      CC.DrawBrush.SetLocation(CC.DrawBrush.Location+chgLoc);
      }

    MouseOverlay.xPos=CC.oldX;
    MouseOverlay.yPos=CC.oldY;
    }
  if (MouseOverlay.pressedKey==1 && CC.DrawBrush!=None)
    {
    CC.DrawBrush.Trigger(self,none);
    MouseOverlay.pressedKey=0;
    }
  if (MouseOverlay.pressedKey==2 && CC.DrawBrush!=None)
    {
    CC.DrawBrush.Trigger(none,none);
    MouseOverlay.pressedKey=0;
    }

  }
MouseOverlay.hudTargetActor=None;
}

DefaultProperties
{
MenuButtons(0)="MSBCode.MSBNaviButton";
MenuButtons(1)="MSBVoxelCharacterEditor.MSBColorSelectButton";
MenuButtons(2)="MSBVoxelCharacterEditor.MSBVoxelCharEditButton";
MenuButtons(3)="MSBVoxelCharacterEditor.MSBVoxelEdPoser";
MenuButtons(4)="MSBVoxelCharacterEditor.MSBSpawnMouthButton";
MenuButtons(5)="MSBVoxelCharacterEditor.MSBSwitchModeButton";
MenuButtons(6)="MSBVoxelCharacterEditor.MSBGrowBrushButton";
MenuButtons(7)="MSBVoxelCharacterEditor.MSBShrinkBrushButton";
MenuButtons(8)="MSBCode.MSBBackToMainButton";
//MenuButtons(8)="MSBVoxelCharacterEditor.MSBCreateBobHead";
drawOverlays=true
}
